#include "MyGL.h"


//------------------------------------------------------------------------------
MyGL::MyGL()
: 
_doLighting( false ),
_doClipping( false ),
_doTriangulate( false ),
_doRasterize( false )
{}

//------------------------------------------------------------------------------
MyGL::~MyGL()
{}

//------------------------------------------------------------------------------
bool MyGL::ComputeLighting( vector<GLVertex>& verts )
{ 
  if( !_doLighting )
    return false;

  //
  // YOUR CODE HERE 
  //

  // for just multiply material and lighting diffuse together
  if( light.enabled )
  {
    for( int i=0; i < (int)verts.size(); i++ )
      verts[i].color = light.diffuse * material.diffuse;
  }
  return true;
}

//------------------------------------------------------------------------------
bool MyGL::ClipPolygon( const vector<GLVertex>& vertsIn, vector<GLVertex>& vertsOut )
{  
  if( !_doClipping )
    return false;
 
  //
  // YOUR CODE HERE
  //
  
  // just copy the polygon so we can get to the other parts of the pipeline
  vertsOut = vertsIn;  
  return true;
}

//------------------------------------------------------------------------------
bool MyGL::TriangulatePolygon( const vector<GLVertex>& polygonVerts,
                               vector<GLVertex>& triangleVerts )
{
  if( !_doTriangulate )
    return false;
 
  //
  // YOUR CODE HERE
  //

  // just make a triangle out of the first three vertices for now
  triangleVerts.push_back( polygonVerts[0] );
  triangleVerts.push_back( polygonVerts[1] );
  triangleVerts.push_back( polygonVerts[2] );
  return true;
}

//------------------------------------------------------------------------------
bool MyGL::RasterizeTriangle( GLVertex verts[3] )
{
  if( !_doRasterize )
    return false;

  // 
  // YOUR CODE HERE
  //

  // just render the vertices for now
  for( int i=0; i < 3; i++ )
  {
    GLVertex& v = verts[i];
    RGBAColor color;
    
    if( textureEnabled  )
    {
      if( texture.id != 0 )
      {
        // look up color in the texture
        int x = v.texCoord[0] * (texture.width - 1);
        int y = v.texCoord[1] * (texture.height - 1);
        color = texture.GetPixel( x, y, 0 );
      }
    }
    else
      color = v.color;

    frameBuffer.SetPixel( v.position[0], v.position[1], color );
    if( depthTestEnabled )
      frameBuffer.SetDepth( v.position[0], v.position[1], v.position[2] );
  }

  return true;
}

